LeetCode 113 - Two Sum


LeetCode – Two Sum (Java)
Given an array of integers, find two numbers such that they add up to a specific target number.
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

Hashsmap:
    public int[] twoSum(int[] numbers, int target) {
 HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
 int[] result = new int[2];
 
 for (int i = 0; i < numbers.length; i++) {
  if (map.containsKey(numbers[i])) {
   int index = map.get(numbers[i]);
   result[0] = index+1 ;
   result[1] = i+1;
   break;
  } else {
   map.put(target - numbers[i], i);
  }
 }
 
 return result;
    }
https://leetcode.com/discuss/19298/very-short-and-simple-java-code-for-two-sum
public int[] twoSum(int[] numbers, int target) {

    HashMap<Integer,Integer> hash = new HashMap<Integer,Integer>();
    for(int i = 0; i < numbers.length; i++){

        Integer diff = (Integer)(target - numbers[i]);
        if(hash.containsKey(diff)){
            int toReturn[] = {hash.get(diff)+1, i+1};
            return toReturn;
        }

        hash.put(numbers[i], i);

    }
    return null;
}
https://leetcode.com/discuss/48602/11-lines-and-1-for-in-java
public int[] twoSum(int[] nums, int target) {
    HashMap<Integer, Integer> map = new HashMap<>();
    for(int i = 0; i < nums.length; i++){
        if(map.containsKey(target - nums[i]))
            return new int[] {map.get(target - nums[i]) + 1, i + 1};
        else map.put(nums[i], i);
        }
    return null;
}
思路2:two pointers
http://www.sigmainfy.com/blog/two-sum-problem-analysis-1-sort-hash-unique-solution.html
将array排序,双指针left/right分别指向头尾。然后两个指针分别向中间移动寻找目标。
(1) A[left] + A[right] = target:直接返回(left+1, right+1)。
(2) A[left] + A[right] > target:说明A[right]不可能是解,right--
(3) A[left] + A[right] < target:说明A[left]不可能是解,left++
中止条件:left >= right

但排序会打乱原来数组index的顺序。我们可以建立一个class/struct/pair来存储val/index,并overload operator < 来以val值排序。这样我们可以track排序后每个数的原有index。

重复元素这里无须特殊处理。index 1和index 2分别取找到的两个index的min/max即可。时间复杂度由于排序的关系为O(n log n),额外空间复杂度O(n)。
 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
class Solution {
    class elem {
    public:    
        int val;
        int index;
        elem(int v, int i):val(v),index(i) {}
        bool operator<(const elem &e) const {
            return val<e.val;
        }
    };
    
public:
    vector<int> twoSum(vector<int> &numbers, int target) {
        vector<int> res(2,-1);
        vector<elem> arr;
        for(int i=0; i<numbers.size(); i++) 
            arr.push_back(elem(numbers[i],i));

        sort(arr.begin(),arr.end());
        int left = 0, right = arr.size()-1;
        while(left<right) {
            if(arr[left].val+arr[right].val==target) {
                res[0] = min(arr[left].index,arr[right].index)+1;
                res[1] = max(arr[left].index,arr[right].index)+1;
                break;
            }
            else if(arr[left].val+arr[right].val<target) 
                left++;
            else
                right--;
        }
        return res;
    }
};
http://blog.csdn.net/likecool21/article/details/10504885
http://www.zhangxiaolong.org/archives/844.html
https://leetcode.com/discuss/101950/java-o-nlogn-beats-98-85%25
https://longwayjade.wordpress.com/2015/06/13/leetcode-java-solution-two-sum/
 public int[] twoSum(int[] numbers, int target) {  
  //Copy the original array and sort it
  int N = numbers.length;
  int[] sorted = new int[N];
  System.arraycopy(numbers, 0, sorted, 0, N);
        Arrays.sort(sorted);
        //find the two numbers using the sorted arrays
        int first = 0;
        int second = sorted.length - 1;
        while(first < second){
         if(sorted[first] + sorted[second] < target){
          first++;
          continue;
         }
         else if(sorted[first] + sorted[second] > target){
          second--;
          continue;
         }
         else break;
        }
        int number1 = sorted[first];
        int number2 = sorted[second];
        //Find the two indexes in the original array
        int index1 = -1, index2 = -1;
        for(int i = 0; i < N; i++){
         if((numbers[i] == number1) || (numbers[i] == number2)){
           if(index1 == -1)
            index1 = i + 1;
           else
            index2 = i + 1;
         }
          
        }
        int [] result = new int[]{index1, index2};
        Arrays.sort(result);
  return result;
    }
https://leetcode.com/discuss/71985/my-12ms-o-nlogn-c-solution
https://leetcode.com/discuss/48383/two-c-implementations-o-n-16ms-o-nlogn-12ms
vector<int> twoSum(vector<int>& nums, int target) {
    vector<int> numsCopy(nums.begin(), nums.end());
    sort(numsCopy.begin(), numsCopy.end()); // O(nlogn)

    int i = 0;
    int j = numsCopy.size()-1;

    while (i < j)
    {
        int sum = numsCopy[i] + numsCopy[j];
        if (sum < target)
            i++;
        else if (sum > target)
            j--;
        else
        {
            break;
        }
    }

    return GetIndexOfAddends(nums, numsCopy[i], numsCopy[j]);
}
vector<int> GetIndexOfAddends(const vector<int>& nums, int addend1, int addend2)
{
    vector<int> result;

    for (int i=0; i<nums.size(); i++)
    {
        if (nums[i] == addend1 || nums[i] == addend2)
        {
            result.push_back(i+1);
        }
    }

    return result;
}
http://fisherlei.blogspot.com/2013/03/leetcode-two-sum-solution.html
O(N^2)
public static int[] twoSum(int[] numbers, int target) {
 int[] ret = new int[2];
 for (int i = 0; i < numbers.length; i++) {
  for (int j = i + 1; j < numbers.length; j++) {
   if (numbers[i] + numbers[j] == target) {
    ret[0] = i + 1;
    ret[1] = j + 1;
   }
  }
 }
 return ret;
}
GoLang:
https://github.com/Max-Liu/Leetcode-in-golang/blob/master/two-sum/main.go
func main() {
  nums := []int{2, 7, 11, 15, 18, 22}
  fmt.Println((twoSum(nums, 37)))
}
func twoSum(nums []int, target int) (index1, index2 int) {
  for i1, _ := range nums {
    for i2 := i1 + 1; i2 < len(nums); i2++ {
      if nums[i1]+nums[i2] == target {
        index1 = i1 + 1
        index2 = i2 + 1
      }
    }
  }
  return index1, index2
}

Arraylist<Pair> printPairSums(int[] array, int sum) {
        Arraylist<Pair> result= new Arraylist<Pair>();
        HashMap<Integer, Integer> unpairedCount = new HashMap<Integer, Integer>();
        for (int x : array) {
                int complement = sum - x;
                if (unpairedCount.getOrDefault(complement, 0) > 0) {
                        result.add(new Pair(x, complement));
                        adjustCounterBy(unpairedCount, complement, -1); // decrement complement
                } else {
                        adjustCounterBy(unpairedCount, x, 1); // increment count
                }
        }
        return result;
}

https://reeestart.wordpress.com/2016/06/06/23k-sum/
// O(n) time, O(n) space
public List<List<Integer>> twoSum(int[] nums, int target) {
  List<List<Integer>> result = new ArrayList<>();
  if (nums == null || nums.length == 0) {
    return result;
  }
   
  Map<Integer, List<Integer>> map = new HashMap<>();
  Set<Integer> set = new HashSet<>();
  for (int i = 0; i < nums.length; i++) {
    map.putIfAbsent(nums[i], new ArrayList<>());
    map.get(nums[i]).add(i);
  }
   
  for (int i = 0; i < nums.length; i++) {
    int toFind = target - nums[i];
    if (map.containsKey(toFind)) {
      for (int j : map.get(toFind)) {
        if (i != j && !set.contains(nums[i]) && !set.contains(nums[j])) {
          result.add(new ArrayList<>(Arrays.asList(nums[i], nums[j])));
          set.add(nums[i]);
          set.add(nums[j]);
        }
      }
    }
  }
   
  return result;
}
https://discuss.leetcode.com/topic/39528/a-question-about-two-sum-follow-up-if-duplicates-exists
 I was asked what if duplicates exists.. How do we handle this?
My original thought is worst case nums = [1,1,1,1] target is 2
I think you can doing the same solution that in the case without duplicates, but you need another auxiliary variable to know if the number is duplicate (in this case only remember 2 different index).
something like:
x = num[i]
if ((target - x == x) and isDuplicate(x))
     return {i, idx_previous[x]}
http://www.cnblogs.com/aprilyang/p/6701586.html
Given an array of integers, find how many unique pairs in the array such that their sum is equal to a specific target number. Please return the number of pairs.
Example
Given nums = [1,1,2,45,46,46], target = 47
return 2
1 + 46 = 47
2 + 45 = 47
    public int twoSum(int[] nums, int target) {
        if (nums == null || nums.length == 0) {
            return 0;
        }
        Arrays.sort(nums);
        int start = 0;
        int end = nums.length - 1;
        int count = 0;
        while (start < end) {
            if (nums[start] + nums[end] < target) {
                start++;
            } else if (nums[start] + nums[end] > target) {
                end--;
            } else {
                count++;
                start++;
                end--;
                while (start < end && nums[start] == nums[start - 1]) {
                    start++;
                }
                while (start < end && nums[end] == nums[end + 1]) {
                    end--;
                }
            }
        }
        return count;
    }

    public int twoSum6(int[] nums, int target) {
        if (nums == null || nums.length == 0) {
            return 0;
        }
        Arrays.sort(nums);
        int start = 0;
        int end = nums.length - 1;
        int count = 0;
        while (start < end) {
            if (start > 0 && nums[start] == nums[start - 1]) {
                start++;
                continue;
            }
            if (end < nums.length - 1 && nums[end] == nums[end + 1]) {
                end--;
                continue;
            }
            if (nums[start] + nums[end] < target) {
                start++;
            } else if (nums[start] + nums[end] > target) {
                end--;
            } else {
                count++;
                start++;
            }
        }
        return count;
    }

1. For a list of pairs {[x0, y0], [x1, y1], [x2, y2], ... , [xn, yn]} and an
integer K, the goal is to find a pair of pairs {[xi, yi], [xj, yj] where xi+xj=K
and yi+yj=K
2. dict two sum
given list [[1,2],[2,1],[1,4],[1,0]],k = 3 ,
item指的是[1,2], 让找到item_1[0] +item_2[0] == k and item_1[1] +item_2[1] == k
return 两个item的第一个index的sum 是 k 和 第二个index的sum 是 k
可以是任意两个item
用个dict 存tuple,然后for loop check
为什么要用二分。。。根据pair的第一个数来sort,双指针找到xi + xj == k之后再判断yi + yj是否等于k 不行么。。。。

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts